#include <iostream>
#include <cstring>

using namespace std;

class MyClass {
private:
  char * str;
public:
  MyClass(const char *s) {
    cout << "String constructor: " << s << endl;
    str = strdup(s);
  }
  ~MyClass() {
    free(str);
  }

  MyClass(const MyClass &other) {
    cout << "Copy constructor" << endl;
    str = strdup(other.str);
  }

  const char *toString() {
    return str;
  }
};

int main(int argc, char *argv[]) {
  cout << "-- 0 ---------------------------------------" << endl;
  MyClass mc0("direct initialization");
  cout << "-- 1 ---------------------------------------" << endl;
  MyClass mc1 = "copy initialization";
  cout << "-- 2 ---------------------------------------" << endl;
  MyClass mc2 = {"list initialization"};
  cout << "-- 3 ---------------------------------------" << endl;
  MyClass mc3{"another direct initialization"};

  cout << mc0.toString() << endl
       << mc1.toString() << endl
       << mc2.toString() << endl
       << mc3.toString() << endl;

  return 0;
}
